/*---------------------------------------------------------------------------------
 bbEdgeFlip ( 2004 Slade Taylor [bladestaylor@yahoo.com])
 ----------------------------------------------------------------------------------
 bbEdgeFlip is a plugin for Blackbox for Windows.  For more information,
 please visit [http://bb4win.org] or [http://sourceforge.net/projects/bb4win].
 ----------------------------------------------------------------------------------
 bbEdgeFlip is free software, released under the GNU General Public License,
 version 2, as published by the Free Software Foundation.  It is distributed
 WITHOUT ANY WARRANTY--without even the implied warranty of MERCHANTABILITY
 or FITNESS FOR A PARTICULAR PURPOSE.  Please see the GNU General Public
 License for more details:  [http://www.fsf.org/licenses/gpl.html].
 --------------------------------------------------------------------------------*/

#ifndef _WIN32_WINNT
    #define _WIN32_WINNT 0x0500
#endif

#define VC_EXTRALEAN

#include "../Blackbox/BBApi.h"

//--------------------------------

#define FLIP_TIMER              1

//--------------------------------

#define DESK_LEFT               0
#define DESK_RIGHT              1

//--------------------------------

#define DEFAULT_FLIP_INTERVAL   500
#define DEFAULT_EDGE_WIDTH      2
#define DEFAULT_TRANS           true

//-----------------------------------------------------------------------------

class FlipInfoItem
{
public:
    enum index { NAME_VERSION = 0, APPNAME, VERSION, AUTHOR, RELEASEDATE, WEBLINK, EMAIL };

    static char *Get(int field)
    {
        switch (field)
        {
            case APPNAME:       return "bbEdgeFlip";
            case VERSION:       return "0.0.2";
            case AUTHOR:        return "bladestaylor";
            case RELEASEDATE:   return "March 4, 2004";
            case WEBLINK:       return "http://bb4win.sourceforge.net/bladestaylor/";
            case EMAIL:         return "bladestaylor@yahoo.com";
            case NAME_VERSION:
            default:            return "bbEdgeFlip 0.0.2";
        }
    };
};

static FlipInfoItem FlipInfo;

//-------------------------------------------------------------------------------------

extern "C"
{
    __declspec(dllexport) void endPlugin(HINSTANCE);
    __declspec(dllexport) int beginPlugin(HINSTANCE);
    __declspec(dllexport) LPCSTR pluginInfo(int x) { return FlipInfoItem::Get(x); };
}

//-------------------------------------------------------------------------------------

static LRESULT CALLBACK PluginProc(HWND, UINT, WPARAM, LPARAM);

static void Reconfig();
static void RCSettings();
static void SetTransTrue(HWND);
static void SetTransFalse(HWND);
static void NextWorkspace(WPARAM);

//-------------------------------------------------------------------------------------

static bool (_stdcall *pSetLayeredWindowAttributes)(HWND, COLORREF, BYTE, DWORD);

static POINT    MouseEventPoint;
static char     RCpath[MAX_LINE_LENGTH];
static int      bb_messages[] = {BB_RECONFIGURE, 0};

static int      VScreenX,
                VScreenY,
                VScreenWidth,
                VScreenHeight,
                LeftEdgeThres,
                RightEdgeThres,
                FlipInterval,
                EdgeWidth;

static HWND     hCoreWnd,
                hRightWnd,
                hLeftWnd;

static bool     bWillFlip,
                bTrans;

//-------------------------------------------------------------------------------------
